variables:
  EB_VERSION: "$CI_PROJECT_NAME-$CI_PIPELINE_ID"

stages:
  - build
  - deploy

build-ebs:
  stage: build
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest
  script:
    - apt-get install zip -qy
    - zip -r $CI_PROJECT_NAME .
    - S3_KEY="$EB_VERSION.zip"
    - aws s3 cp $CI_PROJECT_NAME.zip s3://$S3_BUCKET/$S3_KEY
    - aws elasticbeanstalk create-application-version --application-name cicd-backend --version-label $EB_VERSION --source-bundle S3Bucket=$S3_BUCKET,S3Key=$S3_KEY --auto-create-application
  only:
    - master

deploy-ebs:
  stage: deploy
  dependencies:
    - build-ebs
  image: coxauto/aws-ebcli
  script:
    - eb init cicd-backend -p node.js --region $AWS_DEFAULT_REGION
    - eb deploy Cicdbackend-env --version $EB_VERSION
  only:
    - master
